/*
Calculates control-signals E1 and E2 for kernels using dynamic energy-bounds. The signals are written to text-files. 
 
N is the maximum energy of the many-body states. 
 
Variables from the generation of the many-body basis must be loaded.
*/
N;
J=1;
x=zeros(1,length(mpBasen(:,1))*N^2);
y=zeros(1,length(mpBasen(:,1))*N^2);

DE=zeros(1,length(mpBasen(:,1)));
for i=1:1:length(mpBasen(:,1))
    MAX=0;
    for j=1:1:length(mpBasen(1,:))
        EP=EnPartikelBas{mpBasen(i,j)}(1);
        DE(i)=DE(i)+EP;
      if(MAX<EP)
          MAX=EP;
      end
    end  
   DE(i)=floor((N-DE(i)+MAX)/2);   
   y(J:J+((DE(i)+1)*(DE(i)+2)-1))=(DE(i)+1)*ones(1,(DE(i)+1)*(DE(i)+2));
   for k=DE(i):-1:0
       x(J:J+k)=(k+1)*ones(1,k+1);
        J=J+k+1;
   end
end

x=x(1:J-1);
y=y(1:J-1);
cycles=(J-1)

fid1 = fopen('data/E1.txt','w');
fid2 = fopen('data/E2.txt','w');

for i=1:1:cycles
    fprintf(fid1,'%g',x(i));
    fprintf(fid1,'\n');
    fprintf(fid1,'%g',x(i));
    fprintf(fid1,'\n');
    
    fprintf(fid2,'%g',y(i));
    fprintf(fid2,'\n');
    fprintf(fid2,'%g',y(i));
    fprintf(fid2,'\n');
end

fclose(fid1);
fclose(fid2);