#include <stdlib.h>
#include <stdint.h>
#include <math.h>
#include <stdio.h>
#include <math.h>
#include <time.h>
#include <sys/time.h>
#include <MaxCompilerRT.h>

int main(int argc, char* argv[])
{
	char *device_name = (argc==2 ? argv[1] : NULL);
	max_maxfile_t* maxfile;
	max_device_handle_t* device;
     
	int i, k, p,v;

	int P1, P2, P3, P4, EMAX, EM,K;
       	
    int32_t *n;
    int32_t *l;
    int32_t *j;
    int32_t *m;

	int32_t *out1;
	int32_t *out2;
    int32_t *out3;
	int32_t *out4;
    int32_t *out5;
	int32_t *out6;
    int32_t *out7;
	int32_t *out8;


	FILE *fileN;
	FILE *fileL;
	FILE *fileJ;
	FILE *fileM;
    
	char dataN[256];
	char dataL[256];
	char dataJ[256];
	char dataM[256];
    
	char filePathN[] = "n.txt";
	char filePathL[] = "l.txt";
	char filePathJ[] = "j.txt";
	char filePathM[] = "m.txt";

    int cycles;
    int32_t *E1;
	int32_t *E2;
	FILE *fileE1;
	FILE *fileE2;
    E1 = malloc(2*cycles* sizeof(int32_t));
	E2 = malloc(2*cycles* sizeof(int32_t));
    char filePathE1[] = "E1.txt";
	char filePathE2[] = "E2.txt";
    char dataE1[256];
	char dataE2[256];
    fileE1 = fopen(filePathE1, "rt");
    fileE2 = fopen(filePathE2, "rt");
	
	maxfile = max_maxfile_init_A8EnergyBound();
	device = max_open_device(maxfile, device_name);
	max_set_terminate_on_error(device); 
    
	for(v=0;v<cycles;v++) {
        fgets(dataE1, 256, fileE1);
        fgets(dataE2, 256, fileE2);
        sscanf(dataE1, "%d", &E1[v]);
        sscanf(dataE2, "%d", &E2[v]);
	}

	out1 = malloc(4*cycles * sizeof(uint32_t));
	out2 = malloc(4*cycles * sizeof(uint32_t));
    out3 = malloc(4*cycles* sizeof(uint32_t));
	out4 = malloc(4*cycles * sizeof(uint32_t));
    out5 = malloc(4*cycles * sizeof(uint32_t));
	out6 = malloc(4*cycles * sizeof(uint32_t));
	out7 = malloc(4*cycles * sizeof(uint32_t));
	out8 = malloc(4*cycles * sizeof(uint32_t));

	fileN = fopen(filePathN, "rt");
	fileL = fopen(filePathL, "rt");
	fileJ = fopen(filePathJ, "rt");
	fileM = fopen(filePathM, "rt");
	k = 0;

	n = malloc(2*K* sizeof(int32_t));
	l = malloc(2*K* sizeof(int32_t));
	j = malloc(2*K* sizeof(int32_t));
	m = malloc(2*K* sizeof(int32_t));

	while (fgets(dataN, 256, fileN) != NULL) {
	  fgets(dataL, 256, fileL);
	  fgets(dataJ, 256, fileJ);
	  fgets(dataM, 256, fileM);

	  sscanf(dataN, "%d", &n[k]);
	  sscanf(dataL, "%d", &l[k]);
	  sscanf(dataJ, "%d", &j[k]);
	  sscanf(dataM, "%d", &m[k]);
	  k++;
	}

	max_set_scalar_input(device, "A8EnergyBoundKernel.P1", P1, FPGA_A);
	max_set_scalar_input(device, "A8EnergyBoundKernel.P2", P2, FPGA_A);
	max_set_scalar_input(device, "A8EnergyBoundKernel.P3", P3, FPGA_A);
	max_set_scalar_input(device, "A8EnergyBoundKernel.P4", P4, FPGA_A);
	max_set_scalar_input(device, "A8EnergyBoundKernel.EMAX", EMAX, FPGA_A);
/*For non-dynamic energy-bound, use:
 max_set_scalar_input(device, "A8EnergyBoundKernel.EM", EM, FPGA_A);
*/
    struct timeval startTime;
	struct timeval endTime;
	char bufferStartTime[50];
	char bufferEndTime[50];
    
	gettimeofday(&startTime, 0);
	time_t startTimeT = startTime.tv_sec;
	struct tm *startDateTm = localtime(&startTimeT);
	strftime(bufferStartTime, sizeof(bufferStartTime), "%a %b %Y %H:%M:%S",
             startDateTm);

/*For non-dynamic energy-bound, use:
	max_run(device,
		max_input("n", n, K * sizeof(int32_t)),
		max_input("l", l, K * sizeof(int32_t)),
		max_input("j", j, K * sizeof(int32_t)),
		max_input("m", m, K * sizeof(int32_t)),
		max_output("out1", out1,4*cycles* sizeof(int32_t)),
		max_output("out2", out2,4*cycles * sizeof(int32_t)),
        max_output("out3", out3,4*cycles * sizeof(int32_t)),
        max_output("out4", out4,4*cycles* sizeof(int32_t)),
        max_output("out5", out5,4*cycles * sizeof(int32_t)),
        max_output("out6", out6,4*cycles * sizeof(int32_t)),
        max_output("out7", out7,4*cycles * sizeof(int32_t)),
        max_output("out8", out8,4*cycles * sizeof(int32_t)),
        max_runfor("A8EnergyBoundKernel",cycles),
        max_end());
 For dynamic energy-bound, use:
    max_run(device,
        max_input("n", n, K * sizeof(int32_t)),
        max_input("l", l, K * sizeof(int32_t)),
        max_input("j", j, K * sizeof(int32_t)),
        max_input("m", m, K * sizeof(int32_t)),
        max_input("E1", E1, cycles * sizeof(int32_t)),
        max_input("E2", E2, cycles * sizeof(int32_t)),
        max_output("out1", out1,4*cycles* sizeof(int32_t)),
        max_output("out2", out2,4*cycles * sizeof(int32_t)),
        max_output("out3", out3,4*cycles * sizeof(int32_t)),
        max_output("out4", out4,4*cycles* sizeof(int32_t)),
        max_output("out5", out5,4*cycles * sizeof(int32_t)),
        max_output("out6", out6,4*cycles * sizeof(int32_t)),
        max_output("out7", out7,4*cycles * sizeof(int32_t)),
        max_output("out8", out8,4*cycles * sizeof(int32_t)),
        max_runfor("A8EnergyBoundKernel",cycles),
        max_end());
 */
 
    gettimeofday(&endTime, 0);
	time_t endTimeT = endTime.tv_sec;
	struct tm *endDateTm = localtime(&endTimeT);
	strftime(bufferEndTime, sizeof(bufferEndTime), "%a %b %Y %H:%M:%S", endDateTm);
    
    
	int seconds = endTime.tv_sec - startTime.tv_sec;
	int microseconds = (endTime.tv_usec - startTime.tv_usec);
    
	if (microseconds < 0) {
		seconds -= 1;
		microseconds = (1000000 - startTime.tv_usec) + endTime.tv_usec;
	}
    
    printf("\nProgram started executing at %s\n", bufferStartTime);
	printf("Program finished executing at %s\n", bufferEndTime);
	printf("Total runtime (in seconds): %d.%d\n", seconds, microseconds);
	
	max_close_device(device);
	max_destroy(maxfile);

	return status;
}
